/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package queryTest;


import de.congrace.exp4j.UnknownFunctionException;
import de.congrace.exp4j.UnparsableExpressionException;
import java.util.HashMap;
import org.junit.*;
import static org.junit.Assert.*;
import java.util.HashMap;
import org.junit.*;
import org.ow2.chereos.iots.common.Location;
import org.ow2.choreos.query.constants.Selector;
import org.ow2.choreos.query.constants.Setter;
import org.ow2.choreos.query.constants.Where;
import org.ow2.choreos.query.impl.Query;
import org.ow2.choreos.sparqlfunctions.constants.Concept;
import org.ow2.choreos.sparqlfunctions.constants.FinalResult;
import org.ow2.choreos.sparqlfunctions.constants.Measurement;
import org.ow2.choreos.sparqlfunctions.constants.Parameter;
import org.ow2.choreos.sparqlfunctions.constants.Unit;
import org.ow2.choreos.sparqlfunctions.impl.SparqlImpl;

/**
 *  
 * @author krishna
 */

public class NoiseLevelCheck {
      /**
	 * we supply a single parameter in the hashmap which have the concept noiselevel
         * required unit is db
	 */

    @Test
    public void testcomputeQueryConcept() throws UnparsableExpressionException, UnknownFunctionException {
        System.out.println("computeQueryConcept");
        HashMap<Parameter,Measurement> m1=new HashMap<Parameter,Measurement>();
        SparqlImpl sparql= new SparqlImpl();
        m1.put(new Parameter("x",new Unit("db"),new Concept("noiselevel"),""), new Measurement((double)250));
        //above is the formation of Parameter value HashMap
        //to be passed in the function query.computeQueryConcept as argument 
        Query query=new Query(new Selector(new Concept("noiselevel")),new Setter(new Where("noiselevel.unit.equals=db")),new Location("paris"));
        //to compute concept
        HashMap<Concept, FinalResult> result=query.computeQueryConcept(m1,"average");//m1 is the Parameter value hashMap
        assertEquals("Result",250,sparql.average(result),3);
                                                               
       
    } 
    

    /**
	 * we supply a single parameter in the hashmap which have the concept noiselevel
         * required unit is a insignificant unit(not available)
         * first value will be returned
	 */

    @Test
    public void testcomputeQueryConcept2() throws UnparsableExpressionException, UnknownFunctionException {
        System.out.println("computeQueryConcept2");
        HashMap<Parameter,Measurement> m1=new HashMap<Parameter,Measurement>();
        SparqlImpl sparql= new SparqlImpl();
        m1.put(new Parameter("x",new Unit("db"),new Concept("noiselevel"),""), new Measurement((double)250));
        //above is the formation of Parameter value HashMap
        //to be passed in the function query.computeQueryConcept as argument
        Query query=new Query(new Selector(new Concept("noiselevel")),new Setter(new Where("noiselevel.unit.equals=anything")),new Location("paris"));
        //to compute concept
        HashMap<Concept, FinalResult> result=query.computeQueryConcept(m1,"average");//m1 is the Parameter value hashMap
        assertEquals("Result",250,sparql.average(result),3);


    }

    /**
	 * we supply a single parameter in the hashmap which have the concept noiselevel
         * WITHOUT A SETTER
         * FIRST VALUE IS RETURNED
	 */

    @Test
    public void testcomputeQueryConcept3() throws UnparsableExpressionException, UnknownFunctionException {
        System.out.println("computeQueryConcept3");
        HashMap<Parameter,Measurement> m1=new HashMap<Parameter,Measurement>();
        SparqlImpl sparql= new SparqlImpl();
        m1.put(new Parameter("x",new Unit("db"),new Concept("noiselevel"),""), new Measurement((double)250));
        //above is the formation of Parameter value HashMap
        //to be passed in the function query.computeQueryConcept as argument
        Query query=new Query(new Selector(new Concept("noiselevel")),new Location("paris"));
        //to compute concept
        HashMap<Concept, FinalResult> result=query.computeQueryConcept(m1,"average");//m1 is the Parameter value hashMap
        assertEquals("Result",250,sparql.average(result),3);


    }


}
