package com.ebmwebsourcing.easyesb.component.cd;

import java.util.logging.Logger;

import com.ebmwebsourcing.easyesb.cdk.ESBHelper;
import com.ebmwebsourcing.easyesb.component.cd.api.CDComponent;
import com.ebmwebsourcing.easyesb.component.cd.impl.CDComponentBehaviourImpl;
import com.ebmwebsourcing.easyesb.soa.api.ESBException;
import com.ebmwebsourcing.easyesb.soa.api.component.Component;
import com.ebmwebsourcing.easyesb.soa.api.config.Configuration;
import com.ebmwebsourcing.easyesb.soa.api.factory.ESBCoreFactory;
import com.ebmwebsourcing.easyesb.soa.api.factory.creation.AbstractComponentCreationFactory;
import com.ebmwebsourcing.easyesb.soa.api.node.Node;
import com.ebmwebsourcing.easyesb.soa.api.node.NodeBehaviour;

public class CDComponentCreationFactory extends AbstractComponentCreationFactory {

	private static Logger log = Logger.getLogger(CDComponentCreationFactory.class.getName());

	@Override
	public String getId() {
		return "cd-component-factory";
	}

	public Component<?> createComponent(ESBCoreFactory factory, Node node, Configuration conf) throws ESBException {
		final Component<?> myComponent = ESBHelper.createComponent(node, "CDComponent", CDComponentBehaviourImpl.class);
		myComponent.init();
		// Expose component as WS
		String externalEndpoint = ESBHelper.exposeAsWS(node, myComponent);
		System.out.println(myComponent.getQName() + " is exposed at: " + externalEndpoint);
		
		return myComponent;
	}

}
