/*******************************************************************************
 * Copyright (c) 2011 EBM Websourcing.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Lesser Public License v2.1
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * 
 * Contributors:
 *     EBM Websourcing - initial API and implementation
 ******************************************************************************/
package com.ebmwebsourcing.easyesb.component.cd.impl;

import java.util.List;

import javax.xml.namespace.QName;

import org.oasisopen.sca.annotation.PolicySets;
import org.oasisopen.sca.annotation.Scope;
import org.oasisopen.sca.annotation.Service;

import com.ebmwebsourcing.easyesb.component.cd.api.CDComponent;
import com.ebmwebsourcing.easyesb.soa.api.ESBException;
import com.ebmwebsourcing.easyesb.soa.api.SOAElement;
import com.ebmwebsourcing.easyesb.soa.api.endpoint.behaviour.EndpointBehaviour;
import com.ebmwebsourcing.easyesb.soa.impl.component.ComponentImpl;
import com.ebmwebsourcing.easyesb.soa10.api.type.ComponentType;
import com.ebmwebsourcing.easyesb.technical.service.admin.impl.endpoint.behaviour.UserManagementEndpointBehaviourImpl;

@Scope("COMPOSITE")
@Service(value=CDComponent.class, names="service")
@PolicySets("frascati:scaEasyCompositeWithContent")
public class CDComponentImpl extends ComponentImpl<ComponentType> implements CDComponent {


	public CDComponentImpl() throws ESBException {
		super();
	}

	public CDComponentImpl(QName name, ComponentType model, List<Class<? extends EndpointBehaviour>> behaviourClass,
			SOAElement<?> parent) throws ESBException {
		super(model, parent);
	}

	@Override
	public void init() throws ESBException {
		super.init();
		this.addBehaviourClass(CDComponentDeployBehaviourImpl.class);
		this.addBehaviourClass(CDComponentBehaviourImpl.class);
		
		
		
	}
	

	@Override
	public Object getContext() {

		return null;

	}

}
