package com.ebmwebsourcing.easyesb.component.cd.impl;

import java.net.URI;
import java.net.URISyntaxException;

import javax.xml.namespace.QName;

import com.ebmwebsourcing.easycommons.research.util.SOAException;
import com.ebmwebsourcing.easycommons.research.util.easybox.SOAUtil;
import com.ebmwebsourcing.easycommons.research.util.esb.ESBUtil;
import com.ebmwebsourcing.easycommons.research.util.esb.EndpointAddress;
import com.ebmwebsourcing.easyesb.component.cd.api.CDComponent;
import com.ebmwebsourcing.easyesb.component.cd.api.CDComponentDeployBehaviour;
import com.ebmwebsourcing.easyesb.constant.EasyESBFramework;
import com.ebmwebsourcing.easyesb.esb.impl.ESBFactoryImpl;
import com.ebmwebsourcing.easyesb.external.protocol.soap.impl.SOAPListenerImpl;
import com.ebmwebsourcing.easyesb.external.protocol.soap.impl.server.SoapServer;
import com.ebmwebsourcing.easyesb.soa.api.ESBException;
import com.ebmwebsourcing.easyesb.soa.api.config.Configuration;
import com.ebmwebsourcing.easyesb.soa.api.endpoint.ClientProxyEndpoint;
import com.ebmwebsourcing.easyesb.soa.api.endpoint.ProviderEndpoint;
import com.ebmwebsourcing.easyesb.soa.api.node.Node;
import com.ebmwebsourcing.easyesb.soa.api.node.NodeBehaviour;
import com.ebmwebsourcing.easyesb.soa.impl.endpoint.ClientProxyEndpointImpl;
import com.ebmwebsourcing.easyesb.soa.impl.endpoint.behaviour.specific.ClientProxyBehaviourImpl;
import com.ebmwebsourcing.easyesb.soa.impl.factory.ESBCoreFactoryImpl;
import com.ebmwebsourcing.easyesb.soa10.api.element.ListenerInitialisation;
import com.ebmwebsourcing.easyesb.technical.service.admin.impl.AdminServiceCreationFactory;

public class ESBCDFactoryImpl extends ESBCoreFactoryImpl{

	private Configuration conf;

	public ESBCDFactoryImpl(String ... excludedFactories) {
		super(excludedFactories);


	}

	@Override
	public Node createNode(QName name, Configuration conf) throws ESBException {


		Node node = super.createNode(name, conf);

		this.conf = conf;

		try{


			CDComponent component = (CDComponent) ((NodeBehaviour)node.findBehaviour(NodeBehaviour.class)).createComponent(CDComponent.NAME, CDComponentImpl.class);
//			assert component != null;
//			//		component.addBehaviourClass(BPELComponentAdministrationBehaviourImpl.class);

			

			this.expose(node, component);

			// Get and Expose Admin service
			AdminServiceCreationFactory adminFactory = (AdminServiceCreationFactory) this.servicesFactory.get("admin-service-factory");
			adminFactory.exposeAdminService(node);

		}catch(Exception e){
			throw new ESBException(e);
		}

		return node;
	}

	//	@Override
	//	public void addSpecificElements(QName name, Node node, Configuration conf)
	//			throws ESBException {
	//		super.addSpecificElements(name, node, conf);
	//		new CDComponentExtensionFactory().addSpecificElements(name, node, conf);
	//	}

	//	public ESBCDFactoryImpl() {
	//		
	//		new CDComponentExtensionFactory().
	//	}

	/*
	 * Exposes services provided by the BPEL Component as External Web Services
	 */
	public void expose(Node node, CDComponent cdComponent) throws ESBException{

		ListenerInitialisation listenerInit = SOAUtil.getInstance().getXmlContext(EasyESBFramework.getInstance()).getXmlObjectFactory().create(ListenerInitialisation.class);
		listenerInit.setClassName(SOAPListenerImpl.class.getName());
		listenerInit.setServerName(SoapServer.DEFAULT_NAME);
		System.out.println("CD service endpoint NAME : "+cdComponent.getDescription().getServices().iterator().next().getEndpoints()[0].getName());
		ClientProxyEndpoint clientEndpoint = (ClientProxyEndpoint) ((NodeBehaviour)node.findBehaviour(NodeBehaviour.class))
				.createClientEndpoint(new QName(cdComponent.getDescription().getTargetNamespace(), cdComponent.getDescription().getServices().iterator().next().getEndpoints()[0].getName())
										/* new QName("http://com.ebmwebsourcing.easyesb/echo/", "echoSOAPExternal")*/,
										ClientProxyEndpointImpl.class,
										ClientProxyBehaviourImpl.class,
										null,
										listenerInit);
		clientEndpoint.setProviderServiceName(cdComponent.getQName());
		EndpointAddress epr;
		try {
			epr = ESBUtil.analyzeURI(cdComponent.getReference());

			clientEndpoint.setProviderEndpointName(epr.getEndpointname());
		} catch (SOAException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new ESBException(e);
		}

	}
}
