package org.petalslink.easiestdemo.client.gui;

import java.util.List;

import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

import org.petalslink.easiestdemo.client.notification.NotifyGui;

public class NotificationTableModel extends AbstractTableModel implements TableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private List<NotifyGui> notifications;

	public NotificationTableModel(List<NotifyGui> notifications) {
		this.notifications = notifications;
	}

	@Override
	public String getColumnName(int col) {
		if(col == 0) {
			return "Emission Date";
		} else if(col == 1) {
			return "Reception Date";
		} else if(col == 2) {
			return "From";
		}
		return null;
	}

	@Override
	public int getColumnCount() {
		return 3;
	}

	@Override
	public int getRowCount() {
		return this.notifications.size();
	}

	@Override
	public Object getValueAt(int row, int col) {
		NotifyGui notify = this.notifications.get(row);
		if(col == 0) {
			return notify.getEmissionDate();
		} else if(col == 1) {
			return notify.getReceptionDate();
		} else if(col == 2) {
			return notify.getFrom();
		}
		return null;
	}

	public NotifyGui getValue(int row) {
		return this.notifications.get(row);
	}

	public void addRow(int row) {  
		//Don't know what to do here  
		this.fireTableRowsInserted(row, 0);  
		this.fireTableRowsInserted(row, 1);  
		this.fireTableRowsInserted(row, 2);  
	} 

}
