package org.petalslink.easiestdemo.client.model.impl.esb;

import javax.xml.namespace.QName;

import org.petalslink.abslayer.service.api.Endpoint;
import org.petalslink.abslayer.service.api.Service;
import org.petalslink.easiestdemo.client.model.api.esb.ClientEndpointProxy;
import org.petalslink.easiestdemo.client.model.api.esb.Node;
import org.petalslink.easiestdemo.client.model.api.ws.MockEndpoint;
import org.petalslink.easiestdemo.client.model.api.ws.MockService;
import org.petalslink.easiestdemo.client.model.impl.ws.MockServiceImpl;

import com.ebmwebsourcing.easycommons.soap.handler.SOAPException;

public class ClientEndpointProxyImpl extends EndpointImpl implements ClientEndpointProxy {

	private QName name;
	private MockService mockService;
	private MockEndpoint mockEndpoint;
	private Service service;
	private Endpoint endpoint;
	
	public ClientEndpointProxyImpl(Node node, QName qName, Endpoint endpoint, Service service) throws SOAPException {
		super(node);
		this.name = qName;
		this.endpoint = endpoint;
		this.service = service;
		
		this.mockService = new MockServiceImpl(service);
		
		for(MockEndpoint ep: this.mockService.getEndpoints()) {
			if(ep.getName().equals(endpoint.getName())) {
				this.mockEndpoint = ep;
				break;
			}
		}
		
	}
	
	
	@Override
	public MockService getService() {
		return mockService;
	}

	@Override
	public MockEndpoint getEndpoint() {
		return mockEndpoint;
	}

	@Override
	public String toString() {
		return this.mockService.toString();
	}
	
	@Override
	public QName getName() {
		return name;
	}
	
}
