package org.petalslink.easiestdemo.client.topology;

import java.awt.Color;

import javax.xml.namespace.QName;

import org.petalslink.easiestdemo.client.gui.Property;
import org.petalslink.easiestdemo.client.model.api.esb.ClientEndpointProxy;
import org.petalslink.easiestdemo.client.model.api.esb.Endpoint;

/**
 * The Ball class creates 5 balls.  Each ball increasingly blends
 * the color white with the specified color.
 */
public class InternalClientProxyEndpointG extends InternalEndpointG {

	public static int DEFAULT_SIZE = 10; 
	
	private ClientEndpointProxy model;
	
    public InternalClientProxyEndpointG(TopologyView topology, ClientEndpointProxy cep) {
    	super(topology);
    	this.model = cep;
        this.color = Color.magenta;
        this.size = DEFAULT_SIZE;
        this.init();
        this.properties.add(new Property("wsdl url", this.model.getEndpoint().getService().getDescription().getDocumentBaseURI()));
		this.properties.add(new Property("node", this.getModel().getNode().getQName().toString()));
    }

    public QName getQName() {
    	return new QName(this.model.getService().getQName().getNamespaceURI(), this.model.getService().getEndpoints().get(0).getName());
    }

	@Override
	public Endpoint getModel() {
		return this.model;
	}
    
    
}  

