package org.petalslink.easiestdemo.client.topology;

import java.awt.Color;

import javax.xml.namespace.QName;

import org.petalslink.easiestdemo.client.gui.Property;
import org.petalslink.easiestdemo.client.model.api.esb.Endpoint;
import org.petalslink.easiestdemo.client.model.api.esb.ProviderEndpoint;

/**
 * The Ball class creates 5 balls.  Each ball increasingly blends
 * the color white with the specified color.
 */
public class InternalProviderEndpointG extends InternalEndpointG {

	public static int DEFAULT_SIZE = 10; 
	
	private ProviderEndpoint model;
	
    public InternalProviderEndpointG(TopologyView topology, ProviderEndpoint pe) {
    	super(topology);
    	this.model = pe;
        this.color = Color.yellow;
        this.size = DEFAULT_SIZE;
        this.init();
        
        this.properties.add(new Property("name", this.getQName().getLocalPart()));
		this.properties.add(new Property("namespace", this.getQName().getNamespaceURI()));
        this.properties.add(new Property("wsdl url", this.model.getEndpoint().getService().getDescription().getDocumentBaseURI()));
		this.properties.add(new Property("node", this.getModel().getNode().getQName().toString()));
    }

	@Override
	public QName getQName() {
		return new QName(this.model.getService().getQName().getNamespaceURI(), this.model.getEndpoint().getName());
	}

	@Override
	public Endpoint getModel() {
		return this.model;
	}

}  

