package org.petalslink.easiestdemo.client.topology;

import java.awt.Color;

import javax.xml.namespace.QName;

import org.petalslink.easiestdemo.client.gui.Property;
import org.petalslink.easiestdemo.client.model.api.gov.ProvidedService;

/**
 * The Ball class creates 5 balls.  Each ball increasingly blends
 * the color white with the specified color.
 */
public class ProvidedServiceG extends InternalEndpointG {

	public static int DEFAULT_SIZE = 10; 
	
	private ProvidedService model;
	
    public ProvidedServiceG(TopologyView topology, ProvidedService cep) {
        super(topology);
    	this.model = cep;
        this.color = new Color(255,127,0);
        this.size = DEFAULT_SIZE;
        this.init();
        this.properties.add(new Property("name", this.model.getName().getLocalPart()));
        this.properties.add(new Property("namespace", this.model.getName().getNamespaceURI()));
        this.properties.add(new Property("wsdl url", this.model.getEndpoint().getService().getDescription().getDocumentBaseURI()));
    }

    public QName getQName() {
    	return this.model.getName();
    }

	public ProvidedService getModel() {
		return this.model;
	}
    
    
}  

