package com.ebmwebsourcing.easyesb.cli.impl.command;

import java.util.List;

import com.ebmwebsourcing.easyesb.cli.impl.AbstractCommand;
import com.ebmwebsourcing.easyesb.cli.impl.AbstractCommandManager;
import com.ebmwebsourcing.easyesb.soa.api.ESBException;
import com.ebmwebsourcing.esstar.management.UserManagementClient;


public class ExitCommand extends AbstractCommand<UserManagementClient> {

	private AbstractCommandManager cm = null;

	public ExitCommand(AbstractCommandManager cm) throws ESBException {
		super(null);
		this.cm = cm;
		this.setName("Exit");
		this.setDescription("Exit");
		this.setShortcut("q");
	}

	@Override
	public void execute() {
		System.out.println("Bye!!!");
		System.exit(0);
	}

	@Override
	protected int doProcess(List<String> args) {
		execute();
		return this.resultCode;

	}

	@Override
	protected boolean validateArgs(List<String> args) {
		if(args.size() == 0){
			return true;
		}
		return false;
	}

	@Override
	public String toString() {
		return "q \t\t\t\t\t\t\t{Quit}";
	}

}
