/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.cd.engine;

import java.util.logging.Level;

import javax.jbi.JBIException;

import org.ow2.petals.cd.engine.su.CDServiceUnitManager;
import org.ow2.petals.component.framework.se.AbstractServiceEngine;
import org.ow2.petals.component.framework.su.AbstractServiceUnitManager;



/**
 * The Core Service Engine component class.
 * 
 * @author Nicolas SALATGE - eBM WebSourcing
 * 
 */
public class CDEngine extends AbstractServiceEngine {

    CoordinationDelegatePrimitives primitives = null;
    
    /**
     * The default constructor
     * 
     */
    public CDEngine() {
        super();

    }



    /**
     * initialize the component
     * 
     * @throws JBIException
     *             impossible to initialize the component
     */
    @Override
    protected final void doInit() throws JBIException {
   
            this.getLogger().log(Level.INFO, "Coordination Delegate Component Intialization...");
            primitives = new CoordinationDelegatePrimitives(this);
            
    }

    @Override
    public void doShutdown() throws JBIException {

    }

    
    @Override
    protected AbstractServiceUnitManager createServiceUnitManager() {
        return new CDServiceUnitManager(this);
    }



	public CoordinationDelegatePrimitives getPrimitives() {
		return primitives;
	}


    
}
