/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.cd.engine.listener;

import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.logging.Logger;

import javax.jbi.messaging.MessagingException;
import javax.xml.bind.JAXBContext;
import javax.xml.namespace.QName;
import javax.xml.transform.TransformerException;
import javax.xml.transform.stream.StreamSource;

import org.ow2.petals.cd.engine.CDEngine;
import org.ow2.petals.cd.engine.message.JBIExternalMessageImpl;
import org.ow2.petals.cd.engine.util.Sender;
import org.ow2.petals.component.framework.api.exception.PEtALSCDKException;
import org.ow2.petals.component.framework.api.message.Exchange;
import org.ow2.petals.component.framework.listener.AbstractJBIListener;

import com.ebmwebsourcing.easycommons.xml.SourceHelper;
import com.ebmwebsourcing.easycommons.xml.XMLPrettyPrinter;


/**
 * This class implements the JBI listener for orchestra engine
 *
 * @author Nicolas SALATGE - eBMWebSourcing
 *
 */
public final class JBIListener extends AbstractJBIListener {


	private Logger log = Logger.getLogger(this.getClass().getCanonicalName());


	static private int currentIndReceiver = 0;

	

	private static JAXBContext jaxbContext;
	private static Exception jaxbContextFail = null;

	/**
	 * The default constructor
	 */
	public JBIListener() {

	}

	
	@Override
	public void init() {
		((CDEngine)this.component).getPrimitives().setJbiListener(this);
	}



	/**
	 * (non-Javadoc)
	 *
	 * @param exchange
	 *            the exchange
	 * @see org.ow2.petals.component.common.listener.AbstractJBIListener#onJBIMessage(org.ow2.petals.component.common.util.MessageExchangeWrapper)
	 */
	@Override
	public boolean onJBIMessage(final Exchange exchange) {
		
		try {
			System.out.println("Message received ...................... unblock called .......");
			/* TODO Policy depending on LTS ... */
			//block(exchange);
			//synchronize(); ?
			((CDEngine)this.component).getPrimitives().unblock(exchange);
			System.out.println("out message\n"+XMLPrettyPrinter.prettyPrint(exchange.getOutMessageContentAsDocument()));
			
		} catch (MessagingException e) {
			this.log.severe("Failed to apply LTS policy ..."+e);
		
		}
		
		return true;
		
	}

//		if(!exchange.isActiveStatus() || exchange.isDoneStatus()) {
//			this.getLogger().finest("Exchange is not in Active Status .... ");
//			return true;
//		}
//
//
//		exchange.setProperty(AsyncMessageManager.ASYNC_ORIGINAL_MESSAGE_PROPERTY, true);
//
//		boolean isInOnly = exchange.isInOnlyPattern();
//
//		try {
//
//			final Sender sender = new Sender(this.getComponent().getContext(), this.getComponent().getChannel(), this.getLogger());
//			final JBIContextImpl context = new JBIContextImpl(exchange, sender, this);
//			final JBIExternalMessageImpl message = new JBIExternalMessageImpl();
//
//			message.setEndpoint(exchange.getEndpointName());
//			message.setService(exchange.getService());
//			message.setOperationName(exchange.getOperation().getLocalPart());
//			//System.out.println("&&&&&&&&&&&&&& inproperty   : "+exchange.getInMessage().getProperty("javax.jbi.messaging.protocol.headers"));
//
//
//			Object headers  = exchange.getInMessage().getProperty("javax.jbi.messaging.protocol.headers");
//			DocumentBuilder db = DocumentBuilders.takeDocumentBuilder();
//			if(headers != null && headers instanceof HashMap){
//
//				HashMap<String, DocumentFragment> prop = (HashMap<String, DocumentFragment>) headers;
//
//				for(Entry<String, DocumentFragment> e : prop.entrySet()){
//					DocumentFragment frag = e.getValue(); 
//					Node fragfrag = frag.cloneNode(true);
//
//					org.w3c.dom.Document docHeader = db.newDocument();
//					Node fragfragfrag = docHeader.importNode(fragfrag, true);
//					docHeader.appendChild(fragfragfrag);
//
//					message.getHeader().addProperty(QName.valueOf(e.getKey()),docHeader);
//				}
//			}
//
//			DocumentBuilders.releaseDocumentBuilder(db);
//			org.w3c.dom.Document doc = exchange.getInMessageContentAsDocument();
//
//
//			org.w3c.dom.Document childDoc = Util.getFirstChildAsDocument(doc);
//			message.setContent(doc.getDocumentElement());
//
//
//
//			ProcessKey key = new ProcessKeyImpl(null, exchange.getService(), exchange.getEndpointName());
//			List<com.ebmwebsourcing.easyviper.core.api.engine.Process> processes = this.core.getEngine().getProcessInstanceRegistry().getProcessInstances(key);
//			System.err.println("How many processes found for message : "+processes.size());
//			for(com.ebmwebsourcing.easyviper.core.api.engine.Process process : processes){
//				Endpoint retrievedEndpoint = this.core.getEngine().findEndpointFromMessage(message, process);
//				ExternalContext ctx = process.getExternalContext(retrievedEndpoint, exchange.getOperation().getLocalPart());
//
//
//				if(ctx == null){
//					if(retrievedEndpoint != null){
//
//						process.addExternalContext(retrievedEndpoint, exchange.getOperationName(), context);
//					}else{
//						Endpoint edp = new EndpointImpl();
//						edp.setEndpointName(exchange.getEndpointName());
//						edp.setInterfaceName(exchange.getInterfaceName());
//						edp.setServiceName(exchange.getService());
//						process.addExternalContext(edp, exchange.getOperationName(), context);
//					}
//				}
//			}
//			System.err.println("MESSAGE NAMESPACE : "+message.getService().getNamespaceURI());
//			if(message.getService().getNamespaceURI().equals(EasyVIPERAdministration.EASYVIPER_ADMINISTRATION_URI)){
//
//				org.w3c.dom.Document response = null;
//
//				if(exchange.getOperationName().endsWith("ubscribe")){
//					response = acceptMessageInExtendedService(doc, key, exchange);
//				}else{
//					response = acceptMessageInExtendedService(doc/*childDoc*/, key, exchange);
//				}
//
//				//org.w3c.dom.Document msgDoc = null; //WSNotificationWriter.getInstance().writeSubscribeResponse(response); 
//
//				NormalizedMessage msg = exchange.getOutMessage();
//
//				DOMSource source = new DOMSource(response);   
//
//				msg.setContent(source);
//
//				exchange.setOutMessage(msg);
//
//				System.err.println("Send message to bc soap ...");
//				return true;
//			}


		
	

	
	private String createjbiModel(QName itf, QName service, String endpoint, InputStream jbiFileAsStream, String bpel, String wsdl) throws PEtALSCDKException {

		String res;
		try {
			res = SourceHelper.toString(new StreamSource(jbiFileAsStream));
		} catch (TransformerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new PEtALSCDKException(e);
		}//su.createString(new StreamSource(jbiFileAsStream));//SourceUtil.createString(new StreamSource(jbiFileAsStream));

		Map<String, String> properties = new HashMap<String, String>();
		properties.put("itfns", itf.getNamespaceURI());
		properties.put("srvns", service.getNamespaceURI());
		properties.put("itf", itf.getLocalPart());
		properties.put("srv", service.getLocalPart());
		properties.put("edp", endpoint);
		properties.put("bpel", bpel);
		properties.put("wsdl_of_bpel", wsdl);

		for (final Entry<String, String> entry : properties.entrySet()) {
			res = res.replaceAll("\\$\\{" + entry.getKey() + "\\}", (String) entry
					.getValue());
		}

		return res;
	}
}

