package com.ebmwebsourcing.petals.services.generation.samples;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import junit.framework.Assert;

import org.apache.xml.resolver.helpers.FileURL;
import org.junit.Test;

import com.ebmwebsourcing.easybox.api.XmlContext;
import com.ebmwebsourcing.easybox.api.XmlContextFactory;
import com.ebmwebsourcing.easybox.api.XmlObjectReadException;
import com.ebmwebsourcing.easybox.api.XmlObjectReader;
import com.ebmwebsourcing.easywsdl11.api.element.Definitions;
import com.ebmwebsourcing.petals.services.generation.AbstractJbiXml;
import com.ebmwebsourcing.petals.services.generation.JbiBeanDelegate;
import com.ebmwebsourcing.petals.services.generation.JbiUtils;
import com.ebmwebsourcing.petals.services.generation.cd.CDSAGeneratorUtil;
import com.ebmwebsourcing.petals.services.generation.cdk5.components.CDProvides10;
import com.ebmwebsourcing.petals.services.generation.main.CDSAGeneratorMain;

public class TestCDSAGeneration {

	
		File installFolder = new File(new File("target"), "sa-generation-folder");
	

	


	@Test
	public void testSampleGeneration() {
                                                                                                                                                
		try {
			/* LTS */
			String ltsFileName = "sample.lts";
			URL ltsResource = Thread.currentThread().getContextClassLoader().getResource(ltsFileName);
		
			
			/* WSDL */
			String wsdlFileName = "SampleWSDLFile.wsdl";
			URL wsdlResource = Thread.currentThread().getContextClassLoader().getResource(wsdlFileName);
		
			
			
			File sa = CDSAGeneratorUtil.generateSA(installFolder, wsdlResource, ltsResource);
			  
			Assert.assertTrue(sa.exists());
			
			
		} catch (Exception e) {
			e.printStackTrace();
			Assert.fail();
		}

	}

	@Test
	public void testMainGeneration() {
                                                                                                                                                
		try {
			/* LTS */
			String ltsFileName = "resources/sample.lts";
		
			
			/* WSDL */
			String wsdlFileName = "resources/SampleWSDLFile.wsdl";
		
			
			
			CDSAGeneratorMain main = new CDSAGeneratorMain();
			String[] args = {"target", wsdlFileName, ltsFileName};
			
			main.main(args);
			  
			
			
			
		} catch (Exception e) {
			e.printStackTrace();
			Assert.fail();
		}

	}
	
}
