/**
 * Copyright (c) 2009, EBM WebSourcing
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 **/

package com.ebmwebsourcing.petals.services.generation.cdk5.components;

import com.ebmwebsourcing.petals.services.generation.cdk5.CdkProvides5BeanDelegate;

/**
 * @author Vincent Zurczak - EBM WebSourcing
 */
public class ScaProvides11 extends CdkProvides5BeanDelegate {

	private String compositeFileLocation;


	/**
	 * Constructor.
	 */
	public ScaProvides11() {
		super();
		addNamespace( "sca", "http://petals.ow2.org/components/sca/version-1" );

	}


	/* (non-Javadoc)
	 * @see com.ebmwebsourcing.jbi.core.jbixml.JbiBeanDelegate
	 * #getComponentSection()
	 */
	@Override
	public String getComponentSection() {

		return "\t\t\t<sca:composite-file>" + this.compositeFileLocation + "</sca:composite-file>";
	}


	/**
	 * @return the compositeFileLocation
	 */
	public String getCompositeFileLocation() {
		return this.compositeFileLocation;
	}


	/**
	 * @param compositeFileLocation the compositeFileLocation to set
	 */
	public void setCompositeFileLocation( String compositeFileLocation ) {
		this.compositeFileLocation = compositeFileLocation;
	}


	/*
	 * (non-Javadoc)
	 * @see com.ebmwebsourcing.jbi.core.jbixml.JbiBeanDelegate#getSuType()
	 */
	@Override
	public String getSuType() {
		return "SCA";
	}
}
