package com.ebmwebsourcing.petals.services.generation.main;

import java.io.File;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;

import com.ebmwebsourcing.petals.services.generation.cd.CDSAGeneratorUtil;


public class CDSAGeneratorMain {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if(args.length != 3){
			System.out.println("Coordination Delegates SA generation USAGE :\n");
			System.out.println("./cdsagenerator.sh <installFolder> <wsdl> <lts>");
			System.exit(-1);
		}

		File currentPath = new File(System.getProperty("user.dir"));
		File installFolder = null;
		try {
			URI installFolderPath = new URI(args[0]);

			if(installFolderPath.isAbsolute()){
				installFolder = new File(installFolderPath);
			}else{

				installFolder = new File(currentPath, installFolderPath.toString());
			}
		} catch (URISyntaxException e) {
			System.err.println("Bad URI given for destination folder of the SA: "+args[0]);
			System.exit(-1);
		} 

		try{
			URL wsdlURL;
			URL ltsURL;

			URI wsdlPath = new URI(args[1]);

			if(wsdlPath.isAbsolute()){
				wsdlURL = wsdlPath.toURL();
			}else{
				wsdlURL = new File(currentPath, wsdlPath.toString()).toURI().toURL();
			}


			URI ltsPath = new URI(args[2]);

			if(ltsPath.isAbsolute()){
				ltsURL = ltsPath.toURL();
			}else{
				ltsURL = new File(currentPath, ltsPath.toString()).toURI().toURL();
			}

			CDSAGeneratorUtil.generateSA(installFolder, wsdlURL, ltsURL);

		}catch (Exception e) {
			e.printStackTrace();
			System.err.println("Error while generating SA ... "+e.getLocalizedMessage());
		}

	}
}